Index: /trunk/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml
===================================================================
--- /trunk/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml	(revision 1836)
+++ /trunk/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml	(revision 1837)
@@ -245,16 +245,13 @@
        <field id="PFeN"        description="Primary production of nano iron"          unit="mol-Fe/m3/s"  axis_ref="deptht" />
        <field id="PFeD"        description="Primary production of diatoms iron"       unit="mol-Fe/m3/s"  axis_ref="deptht" />
-       <field id="Pcal"        description="Calcite production"                       unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Dcal"        description="Calcite dissolution"                      unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Graz"        description="Grazing by microzoo"                      unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Graz2"       description="Grazing by mesozoo"                       unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Nfix"        description="Nitrogen fixation"                        unit="mol-N/m2/s"   axis_ref="deptht" />
-       <field id="ExpPOC"      description="POC export"                               unit="mol-C/m2/s"   axis_ref="deptht" />
-       <field id="ExpGOC"      description="GOC export"                               unit="mol-C/m2/s"   axis_ref="deptht" />
-       <field id="ExpFe1"      description="Nano iron export"                         unit="mol-Fe/m2/s"  axis_ref="deptht" />
-       <field id="ExpFe2"      description="Diatoms iron export"                      unit="mol-Fe/m2/s"  axis_ref="deptht" />
-       <field id="ExpSi"       description="Silicate export"                          unit="mol-Si/m2/s"  axis_ref="deptht" />
-       <field id="Expcal"      description="Calcite export"                           unit="mol-C/m2/s"   axis_ref="deptht" />
-       <field id="Cflx"        description="DIC flux"                                 unit="mol-C/m2/s" />
+       <field id="PCAL"        description="Calcite production"                       unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="DCAL"        description="Calcite dissolution"                      unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="GRAZ"        description="Grazing by zooplankton"                   unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="Nfix"        description="Nitrogen fixation at surface"             unit="mol-N/m2/s"      />
+       <field id="EPC100"      description="Export of carbon particles at 100 m"      unit="mol-C/m2/s"      />
+       <field id="EPFE100"     description="Export of biogenic iron at 100 m"         unit="mol-Fe/m2/s"     />
+       <field id="EPSI100"     description="Export of Silicate at 100 m"              unit="mol-Si/m2/s"     />
+       <field id="EPCAL100"    description="Export of Calcite at 100 m"               unit="mol-C/m2/s"      />
+       <field id="Cflx"        description="DIC flux"                                 unit="mol-C/m2/s"      />
        <field id="Oflx"        description="Oxygen flux"                              unit="mol-C/m2/s" />
        <field id="Kg"          description="Gas transfer"                             unit="mol-C/m2/s/uatm" />
@@ -480,15 +477,12 @@
           <field ref="PFeN"     />
           <field ref="PFeD"     />
-          <field ref="Pcal"     />
-          <field ref="Dcal"     />
-          <field ref="Graz"     />
-          <field ref="Graz2"    />
+          <field ref="PCAL"     />
+          <field ref="DCAL"     />
+          <field ref="GRAZ"     />
+          <field ref="EPC100"   />
+          <field ref="EPFE100"  />
+          <field ref="EPSI100"  />
+          <field ref="EPCAL100" />
           <field ref="Cflx"     />
-          <field ref="ExpPOC"   />
-          <field ref="ExpGOC"   />
-          <field ref="ExpFe1"   />
-          <field ref="ExpFe2"   />
-          <field ref="ExpSi"    />
-          <field ref="Expcal"   />
           <field ref="Oflx"     />
           <field ref="Kg"       />
Index: /trunk/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml
===================================================================
--- /trunk/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml	(revision 1836)
+++ /trunk/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml	(revision 1837)
@@ -58,15 +58,12 @@
        <field id="PFeN"        description="Primary production of nano iron"          unit="mol-Fe/m3/s"  axis_ref="deptht" />
        <field id="PFeD"        description="Primary production of diatoms iron"       unit="mol-Fe/m3/s"  axis_ref="deptht" />
-       <field id="Pcal"        description="Calcite production"                       unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Dcal"        description="Calcite dissolution"                      unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Graz"        description="Grazing by microzoo"                      unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Graz2"       description="Grazing by mesozoo"                       unit="mol-C/m3/s"   axis_ref="deptht" />
-       <field id="Nfix"        description="Nitrogen fixation"                        unit="mol-N/m2/s"   axis_ref="deptht" />
-       <field id="ExpPOC"      description="POC export"                               unit="mol-C/m2/s"   axis_ref="deptht" />
-       <field id="ExpGOC"      description="GOC export"                               unit="mol-C/m2/s"   axis_ref="deptht" />
-       <field id="ExpFe1"      description="Nano iron export"                         unit="mol-Fe/m2/s"  axis_ref="deptht" />
-       <field id="ExpFe2"      description="Diatoms iron export"                      unit="mol-Fe/m2/s"  axis_ref="deptht" />
-       <field id="ExpSi"       description="Silicate export"                          unit="mol-Si/m2/s"  axis_ref="deptht" />
-       <field id="Expcal"      description="Calcite export"                           unit="mol-C/m2/s"   axis_ref="deptht" />
+       <field id="PCAL"        description="Calcite production"                       unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="DCAL"        description="Calcite dissolution"                      unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="GRAZ"        description="Grazing by zooplankton"                   unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="Nfix"        description="Nitrogen fixation at surface"             unit="mol-N/m2/s"      />
+       <field id="EPC100"      description="Export of carbon particles at 100 m"      unit="mol-C/m2/s"      />
+       <field id="EPFE100"     description="Export of biogenic iron at 100 m"         unit="mol-Fe/m2/s"     />
+       <field id="EPSI100"     description="Export of Silicate at 100 m"              unit="mol-Si/m2/s"     />
+       <field id="EPCAL100"    description="Export of Calcite at 100 m"               unit="mol-C/m2/s"      />
        <field id="Cflx"        description="DIC flux"                                 unit="mol-C/m2/s" />
        <field id="Oflx"        description="Oxygen flux"                              unit="mol-C/m2/s" />
@@ -177,15 +174,12 @@
           <field ref="PFeN"     />
           <field ref="PFeD"     />
-          <field ref="Pcal"     />
-          <field ref="Dcal"     />
-          <field ref="Graz"     />
-          <field ref="Graz2"    />
+          <field ref="PCAL"     />
+          <field ref="DCAL"     />
+          <field ref="GRAZ"     />
+          <field ref="EPC100"   />
+          <field ref="EPFE100"  />
+          <field ref="EPSI100"  />
+          <field ref="EPCAL100" />
           <field ref="Cflx"     />
-          <field ref="ExpPOC"   />
-          <field ref="ExpGOC"   />
-          <field ref="ExpFe1"   />
-          <field ref="ExpFe2"   />
-          <field ref="ExpSi"    />
-          <field ref="Expcal"   />
           <field ref="Oflx"     />
           <field ref="Kg"       />