Index: /branches/DEV_r1826_DOC/DOC/TexFiles/Chapters/Chap_DOM.tex
===================================================================
--- /branches/DEV_r1826_DOC/DOC/TexFiles/Chapters/Chap_DOM.tex	(revision 1842)
+++ /branches/DEV_r1826_DOC/DOC/TexFiles/Chapters/Chap_DOM.tex	(revision 1843)
@@ -14,5 +14,5 @@
 %	- daymod: definition of the time domain (nit000, nitend andd the calendar)
 % 	-geo2ocean:  how to switch from geographic to mesh coordinate
-%  - domclo:  closed sea and lakes.... management of closea sea area : specific to global configuration, both forced and coupled
+%     - domclo:  closed sea and lakes.... management of closea sea area : specific to global configuration, both forced and coupled
 
 \gmcomment{STEVEN :maybe a picture of the directory structure in the introduction 
@@ -392,6 +392,6 @@
 \begin{description}
 \item[\jp{jphgr\_mesh}=0]  The most general curvilinear orthogonal grids.
-The coordinates and their first derivatives with respect to $i$ and $j$ are 
-provided in a file, read in \rou{hgr\_read} subroutine of the domhgr module.
+The coordinates and their first derivatives with respect to $i$ and $j$ are provided
+in a input file (\ifile{coordinates}), read in \rou{hgr\_read} subroutine of the domhgr module.
 \item[\jp{jphgr\_mesh}=1 to 5] A few simple analytical grids are provided (see below). 
 For other analytical grids, the \mdl{domhgr} module must be modified by the user. 
@@ -442,5 +442,5 @@
 %        Grid files
 % -------------------------------------------------------------------------------------------------------------
-\subsection{Grid files}
+\subsection{Output Grid files}
 \label{DOM_hgr_files}
 
@@ -507,8 +507,10 @@
 Contrary to the horizontal grid, the vertical grid is computed in the code and no 
 provision is made for reading it from a file. The only input file is the bathymetry 
-(in meters)\footnote{N.B. in full step $z$-coordinate, a \textit{bathy\_level} file can 
-replace the \textit{bathy\_meter} file, so that the computation of the number of 
-wet ocean point in each water column is by-passed}. After reading the bathymetry, 
-the algorithm for vertical grid definition differs between the different options:
+(in meters) (\ifile{bathy\_meter}) 
+\footnote{N.B. in full step $z$-coordinate, a \ifile{bathy\_level} file can replace the 
+\ifile{bathy\_meter} file, so that the computation of the number of wet ocean point 
+in each water column is by-passed}. 
+After reading the bathymetry, the algorithm for vertical grid definition differs 
+between the different options:
 \begin{description}
 \item[\textit{zco}] set a reference coordinate transformation $z_0 (k)$, and set $z(i,j,k,t)=z_0 (k)$.
@@ -553,5 +555,5 @@
 domain width at the central latitude. This is meant for the "EEL-R5" configuration, 
 a periodic or open boundary channel with a seamount. 
-\item[\np{ntopo} = 1] read a bathymetry. The bathymetry file (Netcdf format) 
+\item[\np{ntopo} = 1] read a bathymetry. The \ifile{bathy\_meter} file (Netcdf format) 
 provides the ocean depth (positive, in meters) at each grid point of the model grid. 
 The bathymetry is usually built by interpolating a standard bathymetry product 
@@ -560,8 +562,4 @@
 (all levels are masked).
 \end{description}
-
-When using the rigid lid approximation (\key{dynspg\_rl} is defined) isolated land 
-masses (islands) must be identified by negative integers in the input bathymetry file 
-(see \S\ref{MISC_solisl}).
 
 When a global ocean is coupled to an atmospheric model it is better to represent 
@@ -802,23 +800,9 @@
 gives the number of ocean levels ($i.e.$ those that are not masked) at each 
 $t$-point. mbathy is computed from the meter bathymetry using the definiton of 
-gdept as the number of $t$-points which gdept $\leq$ bathy. Note that in version 
-NEMO v2.3, the user still has to provide the "level" bathymetry in a NetCDF
-file when using the full step option (\np{ln\_zco}), rather than the bathymetry 
-in meters: both will be allowed in future versions.
+gdept as the number of $t$-points which gdept $\leq$ bathy. 
 
 Modifications of the model bathymetry are performed in the \textit{bat\_ctl} 
 routine (see \mdl{domzgr} module) after mbathy is computed. Isolated grid points 
 that do not communicate with another ocean point at the same level are eliminated.
-
-In the case of the rigid-lid approximation when islands occur in the computational 
-domain (\np{ln\_dynspg\_rl}=.true. and \key{island} is defined), the \textit{mbathy} 
-array must be provided and takes values from $-N$ to \jp{jpk}-1. It provides the 
-following information: $mbathy(i,j) = -n, \ n \in \left] 0,N \right]$, $t$-points are 
-land points on the $n^{th}$ island ; $mbathy(i,j) =0$, $t$-points are land points 
-on the main land (continent) ; $mbathy(i,j) =k$, the first $k$ $t$- and $w$-points 
-are ocean points, the others are points below the ocean floor. 
-
-This is used to compute the island barotropic stream function used in the rigid lid 
-computation (see \S\ref{MISC_solisl}).
 
 From the \textit{mbathy} array, the mask fields are defined as follows:
Index: /branches/DEV_r1826_DOC/DOC/TexFiles/Chapters/Chap_TRA.tex
===================================================================
--- /branches/DEV_r1826_DOC/DOC/TexFiles/Chapters/Chap_TRA.tex	(revision 1842)
+++ /branches/DEV_r1826_DOC/DOC/TexFiles/Chapters/Chap_TRA.tex	(revision 1843)
@@ -848,5 +848,5 @@
 \np{ngeo\_flux\_const}, which is also a namelist parameter. If it is set to 2, 
 a spatially varying geothermal heat flux is introduced which is provided 
-in the geothermal\_heating.nc NetCDF file (Fig.\ref{Fig_geothermal}).
+in the \ifile{geothermal\_heating} NetCDF file (Fig.\ref{Fig_geothermal}).
 
 % ================================================================