Index: /branches/CMIP5_IPSL/NEMO/C1D_SRC/diawri_c1d.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/C1D_SRC/diawri_c1d.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/C1D_SRC/diawri_c1d.F90	(revision 1846)
@@ -71,5 +71,5 @@
       !!
       LOGICAL ::   ll_print = .FALSE.                ! =T print and flush numout
-      CHARACTER (len=40) ::   clhstnam, clop, clmx   ! temporary names
+      CHARACTER (len=72) ::   clhstnam, clop, clmx   ! temporary names
       INTEGER ::   inum = 11                         ! temporary logical unit
       INTEGER ::   ji, jj, ik                        ! dummy loop indices
Index: /branches/CMIP5_IPSL/NEMO/LIM_SRC_2/limwri_2.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/LIM_SRC_2/limwri_2.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/LIM_SRC_2/limwri_2.F90	(revision 1846)
@@ -88,5 +88,5 @@
       !!
       INTEGER  ::   ji, jj, jf                      ! dummy loop indices
-      CHARACTER(len = 40)  ::   clhstnam, clop
+      CHARACTER(len = 72)  ::   clhstnam, clop
       REAL(wp) ::   zsto, zjulian, zout,   &  ! temporary scalars
          &          zindh, zinda, zindb, ztmu
Index: /branches/CMIP5_IPSL/NEMO/OPA_SRC/DIA/diagap.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/OPA_SRC/DIA/diagap.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/OPA_SRC/DIA/diagap.F90	(revision 1846)
@@ -72,5 +72,5 @@
       INTEGER ::   ji, jj, jk   ! dummy loop indices
       INTEGER ::   it, itmod    ! time step indices
-      CHARACTER (len=40) ::   clhstnam
+      CHARACTER (len=72) ::   clhstnam
       CHARACTER (len=40) ::   clop
       REAL(wp) ::   zbt, zdt    ! temporary scalar
Index: /branches/CMIP5_IPSL/NEMO/OPA_SRC/DIA/diaptr.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 1846)
@@ -611,5 +611,5 @@
       INTEGER, SAVE, DIMENSION (jpj)     :: ndex_h, ndex_h_atl_30, ndex_h_pac_30, ndex_h_ind_30, ndex_h_ipc_30
 
-      CHARACTER (len=40)       ::   clhstnam, clop, clop_once, cl_comment   ! temporary names
+      CHARACTER (len=72)       ::   clhstnam, clop, clop_once, cl_comment   ! temporary names
       INTEGER                  ::   iline, it, itmod, ji, jj, jk            !
 #if defined key_iomput
Index: /branches/CMIP5_IPSL/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/OPA_SRC/DIA/diawri.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/OPA_SRC/DIA/diawri.F90	(revision 1846)
@@ -197,5 +197,5 @@
       !! * Local declarations
       LOGICAL ::   ll_print = .FALSE.    ! =T print and flush numout
-      CHARACTER (len=40) ::           &
+      CHARACTER (len=72) ::           &
          clhstnam, clop, clmx            ! temporary names
       INTEGER ::   inum = 11             ! temporary logical unit
@@ -613,5 +613,5 @@
 
       !! * Local declarations
-      CHARACTER (len=32) :: clname
+      CHARACTER (len=72) :: clname
       CHARACTER (len=40) :: clop
       INTEGER  ::   &
Index: /branches/CMIP5_IPSL/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/OPA_SRC/IOM/iom.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/OPA_SRC/IOM/iom.F90	(revision 1846)
@@ -989,5 +989,5 @@
       CHARACTER(len=6),DIMENSION( 9) ::   clsuff                   ! suffix name
       CHARACTER(len=1),DIMENSION( 3) ::   clgrd                    ! suffix name
-      CHARACTER(len=50)              ::   clname                   ! file name
+      CHARACTER(len=72)              ::   clname                   ! file name
       CHARACTER(len=1)               ::   cl1                      ! 1 character
       CHARACTER(len=2)               ::   cl2                      ! 1 character
@@ -1082,5 +1082,5 @@
 !!$      CHARACTER(len=1),DIMENSION(4) ::   clgrd = (/ 'T', 'U', 'V', 'W' /)   ! suffix name
       CHARACTER(len=1),DIMENSION(1) ::   clgrd = (/ 'T' /)        ! suffix name
-      CHARACTER(len=50)             ::   clname                   ! file name
+      CHARACTER(len=72)             ::   clname                   ! file name
       CHARACTER(len=1)              ::   cl1                      ! 1 character
       CHARACTER(len=6)              ::   clon,clat                ! name of longitude, latitude
Index: /branches/CMIP5_IPSL/NEMO/OPA_SRC/TRD/trdmld.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 1846)
@@ -45,5 +45,5 @@
    PUBLIC   trd_mld_zint   ! routine called by tracers routines
 
-   CHARACTER (LEN=40) ::  clhstnam         ! name of the trends NetCDF file
+   CHARACTER (len=72) ::  clhstnam         ! name of the trends NetCDF file
    INTEGER ::   nh_t, nmoymltrd
    INTEGER ::   nidtrd, ndextrd1(jpi*jpj)
Index: /branches/CMIP5_IPSL/NEMO/OPA_SRC/TRD/trdvor.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/OPA_SRC/TRD/trdvor.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/OPA_SRC/TRD/trdvor.F90	(revision 1846)
@@ -497,5 +497,5 @@
       !!----------------------------------------------------------------------
       REAL(wp) ::   zjulian, zsto, zout
-      CHARACTER (len=40) ::   clhstnam
+      CHARACTER (len=72) ::   clhstnam
       CHARACTER (len=40) ::   clop
       !!----------------------------------------------------------------------
Index: /branches/CMIP5_IPSL/NEMO/TOP_SRC/SED/sedwri.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/TOP_SRC/SED/sedwri.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/TOP_SRC/SED/sedwri.F90	(revision 1846)
@@ -34,5 +34,5 @@
       INTEGER, INTENT(in) :: kt
 
-      CHARACTER(len = 60)  ::  clhstnam, clop
+      CHARACTER(len = 72)  ::  clhstnam, clop
       INTEGER , SAVE :: nised, nhorised, ndimt52, ndimt51, ndepsed
       REAL(wp), SAVE :: zjulian
Index: /branches/CMIP5_IPSL/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 1846)
@@ -43,5 +43,5 @@
    PUBLIC trd_mld_trc_init
 
-   CHARACTER (LEN=40) ::  clhstnam                                ! name of the trends NetCDF file
+   CHARACTER (len=72) ::  clhstnam                                ! name of the trends NetCDF file
    INTEGER ::   nmoymltrd
    INTEGER ::   ndextrd1(jpi*jpj)
Index: /branches/CMIP5_IPSL/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/TOP_SRC/trcdia.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/TOP_SRC/trcdia.F90	(revision 1846)
@@ -112,5 +112,5 @@
       INTEGER ::   jn
       LOGICAL ::   ll_print = .FALSE.
-      CHARACTER (len=40) :: clhstnam, clop
+      CHARACTER (len=72) :: clhstnam, clop
       CHARACTER (len=20) :: cltra, cltrau
       CHARACTER (len=80) :: cltral
@@ -246,5 +246,5 @@
       !!
       LOGICAL ::   ll_print = .FALSE.
-      CHARACTER (len=40) ::   clhstnam, clop
+      CHARACTER (len=72) ::   clhstnam, clop
       CHARACTER (len=20) ::   cltra, cltrau
       CHARACTER (len=80) ::   cltral
@@ -479,5 +479,5 @@
       !!
       LOGICAL ::   ll_print = .FALSE.
-      CHARACTER (len=40) ::   clhstnam, clop
+      CHARACTER (len=72) ::   clhstnam, clop
       CHARACTER (len=20) ::   cltra, cltrau
       CHARACTER (len=80) ::   cltral
@@ -629,5 +629,5 @@
       !!
       LOGICAL ::   ll_print = .FALSE.
-      CHARACTER (len=40) ::   clhstnam, clop
+      CHARACTER (len=72) ::   clhstnam, clop
       CHARACTER (len=20) ::   cltra, cltrau
       CHARACTER (len=80) ::   cltral
Index: /branches/CMIP5_IPSL/NEMO/TOP_SRC/trcwri.F90
===================================================================
--- /branches/CMIP5_IPSL/NEMO/TOP_SRC/trcwri.F90	(revision 1845)
+++ /branches/CMIP5_IPSL/NEMO/TOP_SRC/trcwri.F90	(revision 1846)
@@ -67,5 +67,5 @@
       CHARACTER (len=20)    :: cltra, cltras
 #if defined key_off_tra
-      CHARACTER (len=40) :: clhstnam
+      CHARACTER (len=72) :: clhstnam
       INTEGER ::   inum = 11            ! temporary logical unit
 #endif