Index: /branches/DEV_r1784_3DF/NEMO/OPA_SRC/DTA/dtasal.F90
===================================================================
--- /branches/DEV_r1784_3DF/NEMO/OPA_SRC/DTA/dtasal.F90	(revision 1855)
+++ /branches/DEV_r1784_3DF/NEMO/OPA_SRC/DTA/dtasal.F90	(revision 1856)
@@ -68,23 +68,19 @@
       
       !! * Local declarations
-     
-      INTEGER ::   ji, jj, jk, jl, jkk   ! dummy loop indicies
-      INTEGER ::   &
-           imois, iman, i15, ik           ! temporary integers
-      INTEGER            :: ierror
+      INTEGER ::   ji, jj, jk, jl, jkk            ! dummy loop indicies
+      INTEGER ::   imois, iman, i15 , ik          ! temporary integers
+      INTEGER ::   ierror
 #if defined key_tradmp
-      INTEGER ::   &
-          il0, il1, ii0, ii1, ij0, ij1   ! temporary integers         
-#endif
-      REAL(wp) ::   zxy, zl
-#if defined key_orca_lev10
-      INTEGER   :: ikr, ikw, ikt, jjk
-      REAL(wp)  :: zfac
-#endif
-      REAL(wp), DIMENSION(jpk) ::   &
-          zsaldta            ! auxiliary array for interpolation
-      CHARACTER(len=100) :: cn_dir          ! Root directory for location of ssr files
-      TYPE(FLD_N)        :: sn_sal
-      LOGICAL , SAVE     :: linit_sal = .FALSE.
+      INTEGER ::   il0, il1, ii0, ii1, ij0, ij1   ! temporary integers
+#endif
+      REAL(wp)::   zxy, zl
+#if defined key_orca_lev10
+      INTEGER ::   ikr, ikw, ikt, jjk 
+      REAL(wp)::   zfac
+#endif
+      REAL(wp), DIMENSION(jpk) ::   zsaldta            ! auxiliary array for interpolation
+      CHARACTER(len=100)       :: cn_dir          ! Root directory for location of ssr files
+      TYPE(FLD_N)              :: sn_sal
+      LOGICAL , SAVE           :: linit_sal = .FALSE.
       !!----------------------------------------------------------------------
       NAMELIST/namdta_sal/cn_dir,sn_sal
@@ -114,6 +110,11 @@
              CALL ctl_stop( 'dta_sal: unable to allocate sf_sal structure' )   ;   RETURN
          ENDIF
-         ALLOCATE( sf_sal(1)%fnow(jpi,jpj,jpk) )
+#if defined key_orca_lev10
+         ALLOCATE( sf_sal(1)%fnow(jpi,jpj,jpkdta  ) )
+         ALLOCATE( sf_sal(1)%fdta(jpi,jpj,jpkdta,2) )
+#else
+         ALLOCATE( sf_sal(1)%fnow(jpi,jpj,jpk  ) )
          ALLOCATE( sf_sal(1)%fdta(jpi,jpj,jpk,2) )
+#endif
 
          ! fill sf_sal with sn_sal and control print
Index: /branches/DEV_r1784_3DF/NEMO/OPA_SRC/DTA/dtatem.F90
===================================================================
--- /branches/DEV_r1784_3DF/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 1855)
+++ /branches/DEV_r1784_3DF/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 1856)
@@ -73,23 +73,19 @@
 
       !! * Local declarations
-      INTEGER ::   ji, jj, jk, jl, jkk       ! dummy loop indicies
-      INTEGER ::   &
-        imois, iman, i15 , ik      ! temporary integers
-      INTEGER            :: ierror
+      INTEGER ::   ji, jj, jk, jl, jkk            ! dummy loop indicies
+      INTEGER ::   imois, iman, i15 , ik          ! temporary integers
+      INTEGER ::   ierror
 #if defined key_tradmp
-      INTEGER ::   &
-         il0, il1, ii0, ii1, ij0, ij1   ! temporary integers
-#endif
-      REAL(wp) ::   zxy, zl
-#if defined key_orca_lev10
-      !!!REAL(wp), DIMENSION(jpi,jpj,jpkdta,2) :: ztem
-      INTEGER   :: ikr, ikw, ikt, jjk 
-      REAL(wp)  :: zfac
-#endif
-      REAL(wp), DIMENSION(jpk) ::   &
-         ztemdta            ! auxiliary array for interpolation
-      CHARACTER(len=100) :: cn_dir          ! Root directory for location of ssr files
-      TYPE(FLD_N)        :: sn_tem
-      LOGICAL , SAVE     :: linit_tem = .FALSE.
+      INTEGER ::   il0, il1, ii0, ii1, ij0, ij1   ! temporary integers
+#endif
+      REAL(wp)::   zxy, zl
+#if defined key_orca_lev10
+      INTEGER ::   ikr, ikw, ikt, jjk 
+      REAL(wp)::   zfac
+#endif
+      REAL(wp), DIMENSION(jpk) ::   ztemdta            ! auxiliary array for interpolation
+      CHARACTER(len=100)       ::   cn_dir             ! Root directory for location of ssr files
+      TYPE(FLD_N)              ::   sn_tem
+      LOGICAL , SAVE           ::   linit_tem = .FALSE.
       !!----------------------------------------------------------------------
       NAMELIST/namdta_tem/cn_dir,sn_tem
@@ -107,8 +103,8 @@
          sn_tem = FLD_N( 'temperature',  -1.  ,  'votemper',  .false.   , .true.  ,  'yearly'  , ''       , ''         )
 
-         REWIND( numnam )         ! ... read in namlist namdta_tem 
+         REWIND( numnam )            ! ... read in namlist namdta_tem 
          READ( numnam, namdta_tem ) 
 
-         IF(lwp) THEN              ! control print
+         IF(lwp) THEN                ! control print
             WRITE(numout,*)
             WRITE(numout,*) 'dta_tem : Temperature Climatology '
@@ -121,8 +117,8 @@
 
 #if defined key_orca_lev10
-         ALLOCATE( sf_tem(1)%fnow(jpi,jpj,jpkdta)   )
+         ALLOCATE( sf_tem(1)%fnow(jpi,jpj,jpkdta  ) )
          ALLOCATE( sf_tem(1)%fdta(jpi,jpj,jpkdta,2) )
 #else
-         ALLOCATE( sf_tem(1)%fnow(jpi,jpj,jpk)   )
+         ALLOCATE( sf_tem(1)%fnow(jpi,jpj,jpk  ) )
          ALLOCATE( sf_tem(1)%fdta(jpi,jpj,jpk,2) )
 #endif
@@ -145,5 +141,5 @@
          
 #if defined key_tradmp
-      IF( cp_cfg == "orca"  .AND. jp_cfg == 2 ) THEN
+      IF( cp_cfg == "orca" .AND. jp_cfg == 2 ) THEN
             
          !                                        ! =======================
Index: /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/fldread.F90
===================================================================
--- /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/fldread.F90	(revision 1855)
+++ /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/fldread.F90	(revision 1856)
@@ -48,5 +48,5 @@
       INTEGER , DIMENSION(2)          ::   nrec_b       ! before record (1: index, 2: second since Jan. 1st 00h of nit000 year)
       INTEGER , DIMENSION(2)          ::   nrec_a       ! after  record (1: index, 2: second since Jan. 1st 00h of nit000 year)
-      REAL(wp) , ALLOCATABLE, DIMENSION(:,:,:)   ::   fnow       ! input fields interpolated to now time step
+      REAL(wp) , ALLOCATABLE, DIMENSION(:,:,:  ) ::   fnow       ! input fields interpolated to now time step
       REAL(wp) , ALLOCATABLE, DIMENSION(:,:,:,:) ::   fdta       ! 2 consecutive record of input fields
       CHARACTER(len = 256)            ::   wgtname      ! current name of the NetCDF weight file acting as a key
@@ -146,5 +146,5 @@
 !CDIR COLLAPSE
                sd(jf)%fdta(:,:,:,1) = sd(jf)%fdta(:,:,:,2)
-               sd(jf)%rotn(1)     = sd(jf)%rotn(2)
+               sd(jf)%rotn(1)       = sd(jf)%rotn(2)
             ENDIF
 
@@ -204,17 +204,16 @@
 
             ! read after data
+            ipk = SIZE( sd(jf)%fdta, 3 )
             IF( LEN(TRIM(sd(jf)%wgtname)) > 0 ) THEN
                CALL wgt_list( sd(jf), kw )
-               ipk = SIZE(sd(jf)%fdta,3)
-               DO jk = 1,ipk
-                  CALL fld_interp( sd(jf)%num, sd(jf)%clvar , kw , sd(jf)%fdta(:,:,jk,2) , sd(jf)%nrec_a(1) )
-               ENDDO
+               DO jk = 1, ipk
+                  CALL fld_interp( sd(jf)%num, sd(jf)%clvar, kw, sd(jf)%fdta(:,:,jk,2), sd(jf)%nrec_a(1) )
+               END DO
             ELSE
-               SELECT CASE( SIZE(sd(jf)%fdta,3) )
-               CASE(1)
+               IF( ipk == 1 ) THEN 
                   CALL iom_get( sd(jf)%num, jpdom_data, sd(jf)%clvar, sd(jf)%fdta(:,:,1,2), sd(jf)%nrec_a(1) )
-               CASE(jpk)
+               ELSE
                   CALL iom_get( sd(jf)%num, jpdom_data, sd(jf)%clvar, sd(jf)%fdta(:,:,:,2), sd(jf)%nrec_a(1) )
-               END SELECT
+               ENDIF
             ENDIF
             sd(jf)%rotn(2) = .FALSE.
@@ -256,11 +255,10 @@
                          vtmp(:,:) = 0.0
                          !
-                         ipk = SIZE( sd(kf)%fdta(:,:,:,nf) ,3 )
-                         DO jk = 1,ipk
+                         DO jk = 1, SIZE( sd(kf)%fdta, 3 )
                             CALL rot_rep( sd(jf)%fdta(:,:,jk,nf),sd(kf)%fdta(:,:,jk,nf),'T', 'en->i', utmp(:,:) )
                             CALL rot_rep( sd(jf)%fdta(:,:,jk,nf),sd(kf)%fdta(:,:,jk,nf),'T', 'en->j', vtmp(:,:) )
                             sd(jf)%fdta(:,:,jk,nf) = utmp(:,:)
                             sd(kf)%fdta(:,:,jk,nf) = vtmp(:,:)
-                         ENDDO
+                         END DO
                          !
                          sd(jf)%rotn(nf) = .TRUE.
@@ -335,6 +333,6 @@
       INTEGER :: inrec          ! number of record existing for this variable
       INTEGER :: kwgt
-      INTEGER :: jk             !vertical loop variable
-      INTEGER :: ipk            !number of vertical levels of sdjf%fdta ( 2D: ipk=1 ; 3D: ipk=jpk )
+      INTEGER :: jk             ! vertical loop variable
+      INTEGER :: ipk            ! number of vertical levels of sdjf%fdta ( 2D: ipk=1 ; 3D: ipk=jpk )
       CHARACTER(LEN=1000) ::   clfmt   ! write format
       !!---------------------------------------------------------------------
@@ -401,18 +399,16 @@
 
          ! read before data into sdjf%fdta(:,:,2) because we will swap data in the following part of fld_read
+         ipk = SIZE( sdjf%fdta, 3 )
          IF( LEN(TRIM(sdjf%wgtname)) > 0 ) THEN
             CALL wgt_list( sdjf, kwgt )
-            ipk = SIZE(sdjf%fdta,3)
-            DO jk = 1,ipk
-               CALL fld_interp( sdjf%num,sdjf%clvar,kwgt,sdjf%fdta(:,:,jk,2),sdjf%nrec_a(1) )
-            ENDDO
+            DO jk = 1, ipk
+               CALL fld_interp( sdjf%num, sdjf%clvar, kwgt, sdjf%fdta(:,:,jk,2), sdjf%nrec_b(1) )
+            END DO
          ELSE
-            SELECT CASE ( SIZE(sdjf%fdta,3) )
-            CASE(1)
-                CALL iom_get( sdjf%num, jpdom_data, sdjf%clvar, sdjf%fdta(:,:,1,2), sdjf%nrec_b(1) )
-            CASE(jpk)
-                if(lwp)write(numout,*)'cbr00 ',sdjf%num,SIZE(sdjf%fdta,3) 
-                CALL iom_get( sdjf%num, jpdom_data, sdjf%clvar, sdjf%fdta(:,:,:,2), sdjf%nrec_b(1) )
-            END SELECT
+            IF( ipk == 1 ) THEN
+               CALL iom_get( sdjf%num, jpdom_data, sdjf%clvar, sdjf%fdta(:,:,1,2), sdjf%nrec_b(1) )
+            ELSE
+               CALL iom_get( sdjf%num, jpdom_data, sdjf%clvar, sdjf%fdta(:,:,:,2), sdjf%nrec_b(1) )
+            ENDIF
          ENDIF
          sdjf%rotn(2) = .FALSE.
@@ -562,5 +558,5 @@
       ELSE
          ! build the new filename if climatological data
-         IF( sdjf%cltype == 'monthly' )   WRITE(sdjf%clname, '(a,"m" ,i2.2)' ) TRIM( sdjf%clrootname ), kmonth   ! add month
+         IF( sdjf%cltype == 'monthly' )   WRITE(sdjf%clname, '(a,"_m",i2.2)' ) TRIM( sdjf%clrootname ), kmonth   ! add month
       ENDIF
       CALL iom_open( sdjf%clname, sdjf%num, ldstop = ldstop, ldiof =  LEN(TRIM(sdjf%wgtname)) > 0 )
Index: /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcblk_clio.F90
===================================================================
--- /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcblk_clio.F90	(revision 1855)
+++ /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcblk_clio.F90	(revision 1856)
@@ -162,5 +162,5 @@
 
          DO ifpr= 1, jpfld
-            ALLOCATE( sf(ifpr)%fnow(jpi,jpj,1) )
+            ALLOCATE( sf(ifpr)%fnow(jpi,jpj,1  ) )
             ALLOCATE( sf(ifpr)%fdta(jpi,jpj,1,2) )
          END DO
@@ -541,5 +541,5 @@
                &                / ( ztatm(ji,jj) - 35.86  + MAX( 0.e0, zmt3 ) )  )
 
-            zev = sf(jp_humi)%fnow(ji,jj,1) * zes                      ! vapour pressure  
+            zev = sf(jp_humi)%fnow(ji,jj,1) * zes                    ! vapour pressure  
             zevsqr(ji,jj) = SQRT( zev * 0.01 )                       ! square-root of vapour pressure
             zqatm(ji,jj) = 0.622 * zev / ( zpatm - 0.378 * zev )     ! specific humidity 
@@ -639,5 +639,5 @@
       p_qns(:,:,:) = z_qlw (:,:,:) - z_qsb (:,:,:) - p_qla (:,:,:)      ! Downward Non Solar flux
 !CDIR COLLAPSE
-      p_tpr(:,:)   = sf(jp_prec)%fnow(:,:,1) / rday                       ! total precipitation [kg/m2/s]
+      p_tpr(:,:)   = sf(jp_prec)%fnow(:,:,1) / rday                     ! total precipitation [kg/m2/s]
       !
 !!gm : not necessary as all input data are lbc_lnk...
@@ -741,5 +741,5 @@
             zes = 611.0 * EXP(  ABS( ztamr ) * MIN ( zmt1, zmt2 )   &              ! Saturation water vapour
                &                     / ( sf(jp_tair)%fnow(ji,jj,1) - 35.86  + MAX( 0.e0, zmt3 ) )  )
-            zev(ji,jj) = sf(jp_humi)%fnow(ji,jj,1) * zes * 1.0e-05                   ! vapour pressure  
+            zev(ji,jj) = sf(jp_humi)%fnow(ji,jj,1) * zes * 1.0e-05                 ! vapour pressure  
          END DO
       END DO
@@ -814,7 +814,7 @@
          DO ji = 1, jpi
             zlmunoon = ASIN( zps(ji,jj) + zpc(ji,jj) ) / rad                         ! local noon solar altitude
-            zcldcor  = MIN(  1.e0, ( 1.e0 - 0.62 * sf(jp_ccov)%fnow(ji,jj,1)   &       ! cloud correction (Reed 1977)
+            zcldcor  = MIN(  1.e0, ( 1.e0 - 0.62 * sf(jp_ccov)%fnow(ji,jj,1)   &     ! cloud correction (Reed 1977)
                &                          + 0.0019 * zlmunoon )                 )
-            pqsr_oce(ji,jj) = zcoef1 * zcldcor * pqsr_oce(ji,jj) * tmask(ji,jj,1)   ! and zcoef1: ellipsity
+            pqsr_oce(ji,jj) = zcoef1 * zcldcor * pqsr_oce(ji,jj) * tmask(ji,jj,1)    ! and zcoef1: ellipsity
          END DO
       END DO
@@ -871,5 +871,5 @@
             zes = 611.0 * EXP(  ABS( ztamr ) * MIN ( zmt1, zmt2 )   &              ! Saturation water vapour
                &                     / ( sf(jp_tair)%fnow(ji,jj,1) - 35.86  + MAX( 0.e0, zmt3 ) )  )
-            zev(ji,jj) = sf(jp_humi)%fnow(ji,jj,1) * zes * 1.0e-05                   ! vapour pressure  
+            zev(ji,jj) = sf(jp_humi)%fnow(ji,jj,1) * zes * 1.0e-05                 ! vapour pressure  
          END DO
       END DO
Index: /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 1855)
+++ /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 1856)
@@ -164,5 +164,5 @@
          ENDIF
          DO ifpr= 1, jfld
-            ALLOCATE( sf(ifpr)%fnow(jpi,jpj,1) )
+            ALLOCATE( sf(ifpr)%fnow(jpi,jpj,1  ) )
             ALLOCATE( sf(ifpr)%fdta(jpi,jpj,1,2) )
          END DO
@@ -262,5 +262,5 @@
       ! ocean albedo assumed to be 0.066
 !CDIR COLLAPSE
-      qsr (:,:) = ( 1. - 0.066 ) * sf(jp_qsr)%fnow(:,:,1) * tmask(:,:,1)                                 ! Short Wave
+      qsr (:,:) = ( 1. - 0.066 ) * sf(jp_qsr)%fnow(:,:,1) * tmask(:,:,1)                                     ! Short Wave
 !CDIR COLLAPSE
       zqlw(:,:) = (  sf(jp_qlw)%fnow(:,:,1) - Stef * zst(:,:)*zst(:,:)*zst(:,:)*zst(:,:)  ) * tmask(:,:,1)   ! Long  Wave
@@ -463,7 +463,7 @@
                ! ... scalar wind at T-point (fld being at T-point)
                zwndi_t = sf(jp_wndi)%fnow(ji,jj,1) - 0.25 * (  pui(ji,jj+1) + pui(ji+1,jj+1)   &
-                  &                                        + pui(ji,jj  ) + pui(ji+1,jj  )  )
+                  &                                          + pui(ji,jj  ) + pui(ji+1,jj  )  )
                zwndj_t = sf(jp_wndj)%fnow(ji,jj,1) - 0.25 * (  pvi(ji,jj+1) + pvi(ji+1,jj+1)   &
-                  &                                        + pvi(ji,jj  ) + pvi(ji+1,jj  )  )
+                  &                                          + pvi(ji,jj  ) + pvi(ji+1,jj  )  )
                z_wnds_t(ji,jj)  = SQRT( zwndi_t * zwndi_t + zwndj_t * zwndj_t ) * tmask(ji,jj,1)
             END DO
@@ -489,7 +489,7 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vect. opt.
-               p_taui(ji,jj) = zcoef_wnorm2 * ( z_wnds_t(ji+1,jj) + z_wnds_t(ji,jj) )                          &
+               p_taui(ji,jj) = zcoef_wnorm2 * ( z_wnds_t(ji+1,jj  ) + z_wnds_t(ji,jj) )                          &
                   &          * ( 0.5 * (sf(jp_wndi)%fnow(ji+1,jj,1) + sf(jp_wndi)%fnow(ji,jj,1) ) - pui(ji,jj) )
-               p_tauj(ji,jj) = zcoef_wnorm2 * ( z_wnds_t(ji,jj+1) + z_wnds_t(ji,jj) )                          &
+               p_tauj(ji,jj) = zcoef_wnorm2 * ( z_wnds_t(ji,jj+1  ) + z_wnds_t(ji,jj) )                          &
                   &          * ( 0.5 * (sf(jp_wndj)%fnow(ji,jj+1,1) + sf(jp_wndj)%fnow(ji,jj,1) ) - pvi(ji,jj) )
             END DO
@@ -517,6 +517,5 @@
                p_qsr(ji,jj,jl) = ( 1. - palb(ji,jj,jl) ) * sf(jp_qsr)%fnow(ji,jj,1) * tmask(ji,jj,1)
                ! Long  Wave (lw)
-               z_qlw(ji,jj,jl) = 0.95 * (  sf(jp_qlw)%fnow(ji,jj,1)       &                         
-                  &                   - Stef * pst(ji,jj,jl) * zst3  ) * tmask(ji,jj,1)
+               z_qlw(ji,jj,jl) = 0.95 * (  sf(jp_qlw)%fnow(ji,jj,1) - Stef * pst(ji,jj,jl) * zst3  ) * tmask(ji,jj,1)
                ! lw sensitivity
                z_dqlw(ji,jj,jl) = zcoef_dqlw * zst3                                               
Index: /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcflx.F90
===================================================================
--- /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 1855)
+++ /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 1856)
@@ -126,5 +126,5 @@
          ENDIF
          DO ji= 1, jpfld
-            ALLOCATE( sf(ji)%fnow(jpi,jpj,1) )
+            ALLOCATE( sf(ji)%fnow(jpi,jpj,1  ) )
             ALLOCATE( sf(ji)%fdta(jpi,jpj,1,2) )
          END DO
Index: /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcice_if.F90
===================================================================
--- /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 1855)
+++ /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 1856)
@@ -81,5 +81,5 @@
             CALL ctl_stop( 'sbc_ice_if: unable to allocate sf_ice structure' )   ;   RETURN
          ENDIF
-         ALLOCATE( sf_ice(1)%fnow(jpi,jpj,1) )
+         ALLOCATE( sf_ice(1)%fnow(jpi,jpj,1  ) )
          ALLOCATE( sf_ice(1)%fdta(jpi,jpj,1,2) )
 
@@ -107,5 +107,5 @@
                !
                zt_fzp  = fr_i(ji,jj)                        ! freezing point temperature
-               zfr_obs = sf_ice(1)%fnow(ji,jj,1)              ! observed ice cover
+               zfr_obs = sf_ice(1)%fnow(ji,jj,1)            ! observed ice cover
                !                                            ! ocean ice fraction (0/1) from the freezing point temperature
                IF( sst_m(ji,jj) <= zt_fzp ) THEN   ;   fr_i(ji,jj) = 1.e0
Index: /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 1855)
+++ /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 1856)
@@ -75,5 +75,5 @@
                CALL ctl_stop( 'sbc_rnf: unable to allocate sf_rnf structure' )   ;   RETURN
             ENDIF
-            ALLOCATE( sf_rnf(1)%fnow(jpi,jpj,1) )
+            ALLOCATE( sf_rnf(1)%fnow(jpi,jpj,1  ) )
             ALLOCATE( sf_rnf(1)%fdta(jpi,jpj,1,2) )
          ENDIF
Index: /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcssr.F90
===================================================================
--- /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 1855)
+++ /branches/DEV_r1784_3DF/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 1856)
@@ -115,5 +115,5 @@
                CALL ctl_stop( 'sbc_ssr: unable to allocate sf_sst structure' )   ;   RETURN
             ENDIF
-            ALLOCATE( sf_sst(1)%fnow(jpi,jpj,1) )
+            ALLOCATE( sf_sst(1)%fnow(jpi,jpj,1  ) )
             ALLOCATE( sf_sst(1)%fdta(jpi,jpj,1,2) )
             !
@@ -128,5 +128,5 @@
                CALL ctl_stop( 'sbc_ssr: unable to allocate sf_sss structure' )   ;   RETURN
             ENDIF
-            ALLOCATE( sf_sss(1)%fnow(jpi,jpj,1) )
+            ALLOCATE( sf_sss(1)%fnow(jpi,jpj,1  ) )
             ALLOCATE( sf_sss(1)%fdta(jpi,jpj,1,2) )
             !